--baleUpdateEvent.lua
--
--@Autor: Alex2009(www.Alex2009.de)
--
--Modifizierung erst nach rcksprache mit mir(Alex2009) erlaubt.
--Modification allowed back only after consultation with me(Alex2009).

baleUpdateEvent = {};
baleUpdateEvent_mt = Class(baleUpdateEvent, Event);

InitEventClass(baleUpdateEvent, "baleUpdateEvent");

function baleUpdateEvent:emptyNew()
    local self = Event:new(baleUpdateEvent_mt);
    self.className = "baleUpdateEvent";
    return self;
end;

function baleUpdateEvent:new(object, grabState)
    local self = baleUpdateEvent:emptyNew()
    self.object = object;
	self.grabState = grabState;
    return self;
end;

function baleUpdateEvent:readStream(streamId, connection)
    local id = streamReadInt32(streamId);
	self.grabState = streamReadBool(streamId);
    self.object = networkGetObject(id);
    self:run(connection);
end;

function baleUpdateEvent:writeStream(streamId, connection)
    streamWriteInt32(streamId, networkGetObjectId(self.object));
	streamWriteBool(streamId, self.grabState);
end;

function baleUpdateEvent:run(connection)
	self.object:grabStateUpdate(self.grabState,true);
    if not connection:getIsServer() then
        g_server:broadcastEvent(baleUpdateEvent:new(self.object, self.grabState), nil, connection, self.object);
    end;
end;

function baleUpdateEvent.sendEvent(object, grabState, noEventSend)
    if noEventSend == nil or noEventSend == false then
        if g_server ~= nil then
            g_server:broadcastEvent(baleUpdateEvent:new(object, grabState), nil, nil, object);
        else
            g_client:getServerConnection():sendEvent(baleUpdateEvent:new(object, grabState));
        end;
    end;
end;